Subject: RE: [AAA-WG]: Msg Header Identifiers??

From: "Martin Julien (ECE)" <[email-masked]>
Date: Thu, 3 May 2001 11:38:50 +0200

Hi Pat,

See enclosed comments.

Martin

> > Should duplicates be also discarded? I would assume that
> > a duplicate message detected based on the Hop-By-Hop Identifier
> > should be discarded, while a duplicate message detected based
> > on the End-to-End Identifier is not so obvious to me.
> 
> For Request, Query or Indication messages, I don't think so. 
> Perhaps there is
> a problem in the proxy chain that caused a message to take 
> two paths. For
> responses or answer, yes it can be discarded.
> 
> > 
> > The introduction of the End-to-End Identifier was to detect
> > when a Diameter client was re-sending a pending request, since
> > it was impatient. Now that we have the DSI-Event "STILL_WORKING",
> > and the Max-Wait-Time AVP, do we still need the End-to-End 
> > Identifier? 
> 
> A home server may want to minimize processing unnecessary 
> packets, and the E2E
> ID would allow it to queue recently sent responses. Of course, the
> Record-Route AVPs and Proxy-State (now Proxy-Info) should 
> have to change.

Ok, I see that we might want to keep the e2e identifier. However, it
remains unclear to me how a duplicate message should be handled by a
server that detects it. If it only discards the Request/Query/Indication
messages, then I guess that the dowstream proxy will retry sending it
again and again, which is not right. Should it be informed that it is
a duplicate message that is already being processed? I guess that we are
having the same problem with duplicate answer/response messages.

> > Anyway, the thing is that if a duplicate detected based on the 
> > End-to-End Identifier is received in the Home server while 
> it is still 
> > processing the previous request, should the Home server send an
> > MRI with a new Result-Code to "Duplicate Message-Still Working"?
> see above on home servers being able to queue recent responses.
> 
> > That would make sure that the Diameter nodes on the way to the Home
> > server do not retry to re-send once more the duplicate message
> > as well. The "Duplicate Message-Still Working" would be an 
> End-to-End
> > error of type Permanent.
> I am not sure that we can guarantee that a dup message will 
> never occur, and
> we need to handle such cases when failures in the network occur.
> 
> PatC
>

---

From: Pat Calhoun <[email-masked]>
Date: Thu, 3 May 2001 14:26:27 -0700

On Thu, May 03, 2001 at 11:38:50AM +0200, Martin Julien (ECE) wrote:
> again and again, which is not right. 

req/query/ind are not dropped. They are responded to. Answer and Responses
are dropped.

Therefore, since requests aren't dropped, it is likely that it will
receive multiple responses.

> Should it be informed that it is

Not at all. Duplication requests could occur due to node failures or
network congestion. So, if multiple copies of a request makes it to a
home server, that's ok. One will surely make it back.

This isn't a process that goes on and on. A request that a max lifetime,
and when it expires, a DSI is returned.

PatC